﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.ListView.XForms;
using Xamarin.Forms;

namespace App2
{
    public class EmployeeViewModel : Behavior<ContentPage>,INotifyPropertyChanged
    {
        #region Fields
        private Syncfusion.ListView.XForms.SfListView ListView;
        private Label label;
        private EmployeeViewModel viewmodel;

        private ObservableCollection<Employee> employeeInfo;
        Random random = new Random();

        #endregion

        #region Properties

        public ObservableCollection<Employee> EmployeeInfo
        {
            get { return employeeInfo; }
            set
            {
                if (employeeInfo != null)
                {
                    employeeInfo = value;
                    RaisedOnPropertyChanged("EmployeeInfo");
                }
            }
        }

        #endregion

        #region Constructor

        public EmployeeViewModel()
        {
            employeeInfo = new ObservableCollection<Employee>();
            for (int i = 0; i < EmployeeNames.Count(); i++)
            {
                var employee = new Employee();
                employee.EmployeeName = EmployeeNames[i];
                employee.DisplayString = employee.EmployeeName[0].ToString();
                employee.ContactNumber = random.Next(720, 799).ToString() + " - " + random.Next(3010, 3999).ToString();
                employeeInfo.Add(employee);
            }
        }
        #endregion

        #region Fields

        private string[] Desgination = new string[]
	   {
				"Marketing Assistant",
				"Engineering Manager",
				"Senior Tool Designer",
				"Tool Designer",
				"Marketing Manager",
				"Production Supervisor",
				"Design Engineer",
				"Production Technician",
				"Design Engineer",
				"Vice President of Engineering",
				"Production Control Manager",
				"Network Administrator",
				"Stocker",
				"Shipping and Receiving Clerk",
				"Quality Assurance Supervisor",
				"Information Services Manager",
				"Master Scheduler",
				"Marketing Specialist",
				"Recruiter",
				"Maintenance Supervisor",
		};

        string[] EmployeeNames = new string[] {
                "Sean Jacobson",
                "Phyllis Allen",
                "Marvin Allen",
                "Michael Allen",
                "Cecil Allison",
                "Oscar Alpuerto",
                "Sandra Altamirano",
                "Selena Alvarad",
                "Emilio Alvaro",
                "Maxwell Amland",
                "Mae Anderson",
                "Ramona Antrim",
                "Sabria Appelbaum",
                "Hannah Arakawa",
                "Kyley Arbelaez",
                "Tom Johnston",
                "Thomas Armstrong",
                "John Arthur",
                "Chris Ashton",
                "Teresa Atkinson",
                "John Ault",
                "Robert Avalos",
                "Stephen Ayers",
                "Phillip Bacalzo",
                "Gustavo Achong",
                "Catherine Abel",
                "Kim Abercrombie",
                "Humberto Acevedo",
                "Pilar Ackerman",
                "Frances Adams",
                "Margar Smith",
                "Carla Adams",
                "Jay Adams",
                "Ronald Adina",
                "Samuel Agcaoili",
                "James Aguilar",
                "Robert Ahlering",
                "Francois Ferrier",
                "Kim Akers",
                "Lili Alameda",
                "Amy Alberts",
                "Anna Albright",
                "Milton Albury",
                "Paul Alcorn",
                "Gregory Alderson",
                "J. Phillip Alexander",
                "Michelle Alexander",
                "Daniel Blanco",
                "Cory Booth",
                "James Bailey"
        };

        #endregion

        #region Interface Members

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion

        #region overrides
        protected override void OnAttachedTo(ContentPage bindable)
        {
            ListView = bindable.FindByName<Syncfusion.ListView.XForms.SfListView>("listView");
            label = bindable.FindByName<Label>("label");
            viewmodel = new EmployeeViewModel();
            ListView.BindingContext = viewmodel;
            ListView.DataSource.DisplayItems.CollectionChanged += DisplayItems_CollectionChanged;
            base.OnAttachedTo(bindable);

        }

        private void DisplayItems_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if (ListView.DataSource.DisplayItems.Count == 0)
            {
                ListView.IsVisible = false;
                label.IsVisible = true;
            }
            if (ListView.DataSource.DisplayItems.Count > 0)
            {
                ListView.IsVisible = true;
                label.IsVisible = false;
            }
        }
        #endregion
    }
}
